///////////////////////////////////////////////////////////
// Softwarebauelemente I, Aufgabe M7.1
//
// author:			Stephan Brumme
// last changes:	January 08, 2001


// import cout to display some data
#include <iostream>
#include "MRoom.h"

// open std namespace
using namespace std;



// define the namespace Room

// Initializes the TRoom structure
void MRoom::Init(TRoom &roo, Ordinal nor, Ordinal ar)
{
	// display in-parameters
	cout<<"MRoom::Init entered"<<endl;
	cout<<"       IN:  NumberOfRooms: "<<nor<<endl;
	cout<<"            Area:          "<<ar<<endl;

	// global counter
	static int nCount = 0;
	roo = ++nCount;

	// display out-parameters
	cout<<"       OUT: TRoom:         "<<roo<<endl;
	cout<<"MRoom::Init left"<<endl<<endl;

//	replaced code:
//	roo.NumberOfRooms = nor;
//	roo.Area = ar;
}


// Compares two exemplars
// returns "true" if attributes of both are equal; "false" otherwise
Boolean MRoom::EqualValue(TRoom roo1, TRoom roo2)
{
	// display in-parameters
	cout<<"MRoom::EqualValue entered"<<endl;
	cout<<"       IN:  Room1: "<<roo1<<endl;
	cout<<"            Room2: "<<roo2<<endl;

	// ask user
	cout<<"-----------------------------------------------------------"<<endl;
	cout<<"Are those rooms equal (Y=yes, else false) ? ";
	char cInput;
	cin>>cInput;
	// display entered char
	cout<<cInput<<endl;
	cout<<"-----------------------------------------------------------"<<endl;

	// convert to Boolean
	Boolean bReturn = (cInput=='Y')||(cInput=='y');

	// display out-parameters
	cout<<"       OUT: return "<<bReturn;
	cout<<"MRoom::EqualValue left"<<endl<<endl;

	return bReturn;

//	replaced code:
//	return ((roo1.Area == roo2.Area) &&
//		    (roo1.NumberOfRooms = roo2.NumberOfRooms));
}


// Copies the attributes of roo2
// returns "true" if successful, "false" if no memory allocated
Boolean MRoom::Copy(TRoom& roo1, TRoom roo2)
{
	// display in-parameters
	cout<<"MRoom::Copy entered"<<endl;
	cout<<"       IN:  Room1: "<<roo1<<endl;
	cout<<"            Room2: "<<roo2<<endl;

	// ask user
	cout<<"-----------------------------------------------------------"<<endl;
	cout<<"Should Room2 be copied to Room1 (Y=yes, else false) ? ";
	char cInput;
	cin>>cInput;
	// display entered char
	cout<<cInput<<endl;
	cout<<"-----------------------------------------------------------"<<endl;

	// convert to Boolean
	Boolean bReturn = (cInput=='Y')||(cInput=='y');
	if (bReturn)
		roo1 = roo2;

	// display out-parameters
	cout<<"       OUT: Room1: "<<roo1<<endl;
	cout<<"            return "<<bReturn;
	cout<<"MRoom::Copy left"<<endl<<endl;

	return bReturn;

//	replaced code:
//	if (EqualValue(roo1, roo2))
//		return false;
//
//	roo1.Area = roo2.Area;
//	roo1.NumberOfRooms = roo2.NumberOfRooms;
//	return true;
}


// Returns the NumberOfRooms attribute
Ordinal MRoom::GetNumberOfRooms(TRoom roo)
{
	// display in-parameters
	cout<<"MRoom::GetNumberOfRooms entered"<<endl;
	cout<<"       IN:  Room: "<<roo<<endl;

	cout<<"-----------------------------------------------------------"<<endl;
	cout<<"How many rooms ? ";
	int nReturn;
	cin>>nReturn;
	// display entered char
	cout<<nReturn<<endl;
	cout<<"-----------------------------------------------------------"<<endl;

	// display out-parameters
	cout<<"            return "<<nReturn;
	cout<<"MRoom::GetNumberOfRooms left"<<endl<<endl;

	return nReturn;

//	replaced code:
//	return roo.NumberOfRooms;
}


// Sets the NumberOfRooms attribute
void MRoom::SetNumberOfRooms(TRoom &roo, Ordinal nor)
{
	// display in-parameters
	cout<<"MRoom::SetNumberOfRooms entered - not affecting anything !"<<endl;
	cout<<"       IN:  Room:          "<<roo<<endl;
	cout<<"            NumberOfRooms: "<<nor<<endl;

	// display out-parameters
	cout<<"MRoom::SetNumberOfRooms left"<<endl<<endl;

//	replaced code:
//	roo.NumberOfRooms = nor;
}


// Returns the Area attribute
Ordinal MRoom::GetArea(TRoom roo)
{
	// display in-parameters
	cout<<"MRoom::GetArea entered"<<endl;
	cout<<"       IN:  Room: "<<roo<<endl;

	cout<<"-----------------------------------------------------------"<<endl;
	cout<<"How many square feet ? ";
	int nReturn;
	cin>>nReturn;
	// display entered char
	cout<<nReturn<<endl;
	cout<<"-----------------------------------------------------------"<<endl;

	// display out-parameters
	cout<<"            return "<<nReturn;

	// display out-parameters
	cout<<"MRoom::GetArea left"<<endl<<endl;

	return nReturn;

//	replaced code:
//	return roo.Area;
}


// Displays the attributes
void MRoom::Show(TRoom roo)
{
	// display in-parameters
	cout<<"MRoom::Show entered - not affecting anything !"<<endl;
	cout<<"       IN:  Room: "<<roo<<endl;

	// display out-parameters
	cout<<"MRoom::Show left"<<endl<<endl;

//	replaced code:
//	cout<<"Es sind "<<roo.NumberOfRooms<<" Raeume mit einer Flaeche von "<<roo.Area
//		<<"."<<endl;
}

// end of namespace Room
